----------------------------------
---- Retro Racer                --
---- (c)2013 Humans Are Puppies --
---- www.humansarepuppies.com   --
----------------------------------

dbg={}

function love.load()
    init_vars()

    -- load files
    font={}
    font.debug=love.graphics.newFont("ttf/libmono.ttf",11)
    font.score=love.graphics.newFont("ttf/libmono.ttf",18)
    font.gover=love.graphics.newFont("ttf/libmono.ttf",22)

    gfx={}
    gfx.car=love.graphics.newImage("png/car.png")
    gfx.car_data=love.image.newImageData("png/car.png")
    gfx.enemy=love.graphics.newImage("png/banana.png")
    gfx.enemy_data=love.image.newImageData("png/banana.png")

    sfx={}
    sfx.score=love.audio.newSource("ogg/score.ogg","static")
    sfx.score:setLooping(false)
    sfx.score:setVolume(0.05)

    sfx.win=love.audio.newSource("ogg/win.ogg","static")
    sfx.win:setLooping(false)
    sfx.win:setVolume(0.3)

    sfx.over=love.audio.newSource("ogg/trashpiano.ogg","static")
    sfx.over:setLooping(false)
    sfx.over:setVolume(0.3)

    sfx.bgmusic=love.audio.newSource("ogg/ifeellove.ogg","stream")
    sfx.bgmusic:setLooping(true)
    sfx.bgmusic:setVolume(0.9)

    start_game()
end

function init_vars()
    -- initialize variables
    game        = { dbg=false, speed=200, accel=200, distance=0, score=0, timer=0, status="run", firstrun=true, endplay=false }
    roadmark    = { top=0 }
    car         = { x=283, y=320, turn=8, dturn=0, dturn_max=2.5 }
    enemy       = {}
    enemy.limit = 460
    enemy.t     = {   1.0,   5.0,   8.0,  12.0,  15.0,  16.0,  16.4,  18.0,  22.0,  22.6,  23.0,  24.3,  25.0,  29.0,  30.0,  30.5,  31.3,  35.0,  37.0,  38.0,
                     38.4,  38.6,  40.0,  40.2,  41.0,  44.3,  44.7,  45.0,  47.0,  47.1,  47.2,  49.0,  50.1,  51.0,  51.1,  53.0,  54.0,  54.3,  54.5,  54.7,
                     55.1,  55.5,  55.8,  56.4,  56.9,  57.8,  58.3,  59.1,  59.4,  59.5,  59.7,  60.1,  61.5,  61.9,  71.7,  72.2,  72.3,  72.5,  72.8,  73.1,
                     73.5,  73.6,  73.9,  73.9,  74.8,  74.9,  75.0,  75.2,  75.3,  75.3,  76.0,  76.1,  76.1,  76.2,  76.4,  76.6,  78.2,  79.5,  80.3,  80.3,
                     80.4,  80.4,  80.5,  80.7,  80.7,  80.9,  81.0,  81.4,  81.5,  81.6,  81.6,  81.8,  82.0,  82.5,  82.7,  82.9,  83.1,  83.3,  83.4,  83.5}
    enemy.x     = {   300,   240,   443,   213,   150,   233,   456,   175,   274,   188,   441,   456,   223,   411,   318,   310,   410,   161,   221,   194,
                      183,   411,   243,   311,   194,   398,   381,   184,   441,   243,   310,   449,   413,   294,   281,   255,   299,   212,   148,   272,
                      196,   381,   449,   392,   191,   421,   267,   385,   252,   169,   177,   448,   432,   364,   411,   297,   214,   412,   286,   411,
                      124,   243,   221,   297,   164,   177,   211,   389,   361,   185,   415,   311,   364,   278,   146,   433,   184,   386,   332,   412,
                      191,   211,   320,   411,   366,   323,   171,   418,   277,   317,   150,   311,   301,   421,   386,   176,   331,   258,   283,   163}

    -- initialize positions
    enemy.y={}
    enemy.scored={}
    for i=1,table.getn(enemy.x) do
        enemy.y[i]=-24
        enemy.scored[i]=false
    end
end

function start_game()
    sfx.win:stop()
    sfx.over:stop()
    sfx.bgmusic:play()
end

function love.update(dt)
    if game.firstrun then game.firstrun=false
    elseif game.status=="run" or game.status=="nearhit" then
        -- update game vars
        game.timer=game.timer+dt
        game.speed=game.speed+(dt*(game.accel/100))
        game.distance=game.distance+(game.speed/100000)

        -- update roadmark positions
        roadmark.top=roadmark.top+(dt*game.speed)
        if roadmark.top>100 then roadmark.top=-100 end

        -- update car position
        axis=love.joystick.getAxis(1,1) or 0
        if (love.keyboard.isDown("left") and not love.keyboard.isDown("right")) or axis<0 then
            if axis~=0 then
                car.dturn=(car.dturn-(car.turn*dt*math.abs(axis)))
                if (car.dturn<-car.dturn_max*math.abs(axis)) then car.dturn=-car.dturn_max*math.abs(axis) end
            else
                car.dturn=car.dturn-(car.turn*dt)
                if (car.dturn<-car.dturn_max) then car.dturn=-car.dturn_max end
            end
        elseif love.keyboard.isDown("right") and not love.keyboard.isDown("left") or axis>0 then
            if axis~=0 then
                car.dturn=(car.dturn+(car.turn*dt*axis))
                if (car.dturn>car.dturn_max*axis) then car.dturn=car.dturn_max*axis end
            else
                car.dturn=car.dturn+(car.turn*dt)
                if (car.dturn>car.dturn_max) then car.dturn=car.dturn_max end
            end
        elseif car.dturn>0 then
            if car.dturn<(car.turn*dt) then car.dturn=0
            else car.dturn=car.dturn-(car.turn*dt) end
        elseif car.dturn<0 then
            if car.dturn>(car.turn*dt) then car.dturn=0
            else car.dturn=car.dturn+(car.turn*dt) end
        end

        car.x=car.x+dt*car.dturn*100

        -- check if car leaves boundaries
        if car.x<139 then
            car.x=139
            if car.dturn<0 then car.dturn=0 end
        end
        if car.x>430 then
            car.x=430
            if car.dturn>0 then car.dturn=0 end
        end

        -- update enemies and check pixel exact collision
        game.status="run"
        for i in pairs(enemy.t) do
            if game.distance>enemy.t[i] and enemy.y[i]<500 then
                enemy.y[i]=enemy.y[i]+(dt*game.speed)
                -- if car passes enemy count as score
                if enemy.y[i]>enemy.limit and enemy.scored[i]==false then
                    enemy.scored[i]=true
                    game.score=game.score+1
                    sfx.score:stop()
                    sfx.score:play()
                -- rectangular collision check
                elseif car.x<enemy.x[i]+gfx.enemy:getWidth() and car.x+gfx.car:getWidth()>enemy.x[i] and enemy.y[i]>295 and enemy.y[i]<448 then
                    game.status="nearhit"
                    -- find rectangle which frames both car and enemy objects completely
                    clrect={}
                    if car.x<enemy.x[i] then clrect.x=car.x else clrect.x=enemy.x[i] end
                    if car.y<enemy.y[i] then clrect.y=car.y else clrect.y=enemy.y[i] end
                    if car.x+gfx.car:getWidth()>enemy.x[i]+gfx.enemy:getWidth() then clrect.w=car.x+gfx.car:getWidth()-clrect.x else clrect.w=enemy.x[i]+gfx.enemy:getWidth()-clrect.x end
                    if car.y+gfx.car:getHeight()>enemy.y[i]+gfx.enemy:getHeight() then clrect.h=car.y+gfx.car:getHeight()-clrect.y else clrect.h=enemy.y[i]+gfx.enemy:getHeight()-clrect.y end
                    -- calculate image positions inside collision box
                    x1=enemy.x[i]-clrect.x
                    y1=enemy.y[i]-clrect.y
                    x2=car.x-clrect.x
                    y2=car.y-clrect.y
                    -- create two imageData with this dimensions
                    climgdata={}
                    climgdata[1]=love.image.newImageData(clrect.w,clrect.h)
                    climgdata[2]=love.image.newImageData(clrect.w,clrect.h)
                    -- project each object to a separate image Data
                    climgdata[1]:paste(gfx.enemy_data,x1,y1)
                    climgdata[2]:paste(gfx.car_data,x2,y2)
                    -- iterate over x and y coords of smaller object with two for loops
                    for y=y1,y1+gfx.enemy:getHeight()-1 do
                        for x=x1,x1+gfx.enemy:getWidth()-1 do
                            r1,g1,b1,a1=climgdata[1]:getPixel(x,y)
                            -- if alpha not zero, check corresponding pixel of other object
                            if a1~=0 then
                                r2,g2,b2,a2=climgdata[2]:getPixel(x,y)
                                -- if other pixel alpha is not zero, we definitely have a collision
                                if a2~=0 then
                                    game.status="hit"
                                    break
                                end
                            end
                        end
                        if game.status=="hit" then break end
                    end
                end
            end
        end

        -- check if game maybe is over already
        if game.timer>enemy.t[table.getn(enemy.t)]+4 then
            game.status="end"
        end
    elseif (game.status=="hit" or game.status=="end") and sfx.bgmusic:isStopped()==false then sfx.bgmusic:stop() end
end

function love.draw()
    -- draw background
    love.graphics.setColor(155,155,155,255)
    love.graphics.rectangle("fill",150,0,360,480)
    love.graphics.setColor(50,215,50,255)
    love.graphics.rectangle("fill",0,0,130,480)
    love.graphics.rectangle("fill",510,0,130,480)

    -- draw inner roadmarks
    love.graphics.setColor(255,255,255,255)
    for i,vi in pairs({253,373}) do
        for j,vj in pairs({0,2,4}) do love.graphics.rectangle("fill",vi,roadmark.top+100*vj,14,100) end
    end

    -- draw outer roadmarks
    for i,vi in pairs({130,490}) do
        for j=-1,5 do
            love.graphics.setColor(255,255,255,255)
            love.graphics.rectangle("fill",vi,roadmark.top+100*j,20,50)
            love.graphics.setColor(255,55,55,255)
            love.graphics.rectangle("fill",vi,roadmark.top+50+100*j,20,50)
        end
    end

    -- draw car
    love.graphics.setColor(255,255,255,255)
    love.graphics.draw(gfx.car,car.x,car.y)

    -- draw enemies
    for i,v in ipairs(enemy.y) do
        if v>-24 and v<500 then
            scale,offset,alpha,rotation=1,0,1,0
            if enemy.scored[i]==true then
                scale=((v-enemy.limit)/10)+1
                offset=(gfx.enemy:getWidth()*scale)/4
                alpha=1-((v-enemy.limit)/50)
                rotation=((v-enemy.limit)/50)*8
            end
            love.graphics.setColor(255,255,255,255*alpha)
            love.graphics.draw(gfx.enemy,enemy.x[i]-offset,v-offset,rotation,scale,scale)
            if game.dbg then
                love.graphics.setColor(255,0,0,150)
                love.graphics.setFont(font.debug)
                love.graphics.print(i,enemy.x[i]+26,v)
            end
        end
    end

    -- if collision or game ended then darken window
    if game.status=="hit" or game.status=="end" then
        love.graphics.setColor(0,0,0,150)
        love.graphics.rectangle("fill",0,0,640,480)
    end

    -- draw scores
    love.graphics.setColor(100,100,100,200)
    love.graphics.rectangle("fill",556,5,73,50)
    love.graphics.setColor(0,255,255,255)
    love.graphics.setFont(font.score)
    love.graphics.print("SCORE\n"..string.format("%05d",game.score),564,10)

    -- draw debug if enabled
    if game.dbg==true then dbg.draw() end

    -- if collision then draw game over message
    if game.status=="hit" then
        if game.endplay==false then
            sfx.over:play()
            game.endplay=true
        end
        love.graphics.setFont(font.gover)
        love.graphics.setColor(80,80,80,255)
        love.graphics.print("A SOMALIAN CHILD DIES OF HUNGER"..
                          "\nBECAUSE YOU SQUASHED HIS BANANA!",116,102)
        love.graphics.print("   GAME OVER!"..
                          "\nPLAY AGAIN? (Y/N)",212,212)
        love.graphics.setColor(255,255,255,255)
        love.graphics.print("A SOMALIAN CHILD DIES OF HUNGER"..
                          "\nBECAUSE YOU SQUASHED HIS BANANA!",114,100)
        love.graphics.print("   GAME OVER!"..
                          "\nPLAY AGAIN? (Y/N)",210,210)
    end

    -- if game over draw message
    if game.status=="end" then
        if game.endplay==false then
            sfx.win:play()
            game.endplay=true
        end
        love.graphics.setFont(font.gover)
        love.graphics.setColor(80,80,80,255)
        love.graphics.print("    YES, YOU'VE MADE IT!"..
                          "\nALL BANANAS ARE SAFE AND THE"..
                          "\n    CHILDREN ARE HAPPY.",142,102)
        love.graphics.print("    THE END."..
                          "\nPLAY AGAIN? (Y/N)",222,212)
        love.graphics.setColor(255,255,255,255)
        love.graphics.print("    YES, YOU'VE MADE IT!"..
                          "\nALL BANANAS ARE SAFE AND THE"..
                          "\n    CHILDREN ARE HAPPY.",140,100)
        love.graphics.print("    THE END."..
                          "\nPLAY AGAIN? (Y/N)",220,210)
    end
end

function love.keypressed(key)
    if key=="escape" then love.event.push("quit") end
    if key=="d" then
        if game.dbg==true then game.dbg=false
        else game.dbg=true end
    end
    if key=="n" and (game.status=="hit" or game.status=="end") then love.event.push("quit")
    elseif key=="y" and (game.status=="hit" or game.status=="end") then
        init_vars()
        start_game()
    end
end

function dbg.draw()
    if game.status=="nearhit" or game.status=="hit" then
        love.graphics.setColor(255,0,0,100)
        love.graphics.rectangle("line",clrect.x,clrect.y,clrect.w,clrect.h)
        love.graphics.setColor(100,100,0,100)
        love.graphics.rectangle("line",x1+clrect.x,y1+clrect.y,gfx.enemy:getWidth(),gfx.enemy:getHeight())
        love.graphics.setColor(0,0,255,100)
        love.graphics.rectangle("line",x2+clrect.x,y2+clrect.y,gfx.car:getWidth(),gfx.car:getHeight())
    end
    love.graphics.setColor(100,100,100,200)
    love.graphics.rectangle("fill",5,5,176,70)
    love.graphics.setColor(200,200,255,200)
    love.graphics.setFont(font.debug)
    love.graphics.print("fps           : "..love.timer.getFPS()..
    "\ngame.speed    : "..string.format("%.2f",game.speed)..
    "\ngame.timer    : "..string.format("%.2f",game.timer)..
    "\ngame.distance : "..string.format("%.2f",game.distance)..
    "\ncar.dturn     : "..string.format("%.2f",car.dturn),10,10)
end
